
; Definitionen fr Mega8515

; Belegungen der Atmel-Ports:

;*****************************************************************

;	PA0		ADC0		TUNER_FE ADC Feldstrke		
;	PA1		ADC1		RDS Qualitt
;	PA2		ADC2		
;	PA3		ADC3      	
;	PA4		ADC4		TUNER_CE
;	PA5		ADC5		TUNER_ST
;	PA6		ADC6		TUNER_OK
;	PA7		ADC7		TUNER_MU

;	PB0		XCK/T0		LCD_D0			
;	PB1		T1			LCD_D1	
;	PB2		INT2/AIN0	LCD_D2
;	PB3		OC0/AIN1	LCD_D3
;	PB4		SS			LCD_D4
;	PB5		MOSI	ISP	LCD_D5
;	PB6		MISO	ISP	LCD_D6
;	PB7		SCK		ISP	LCD_D7
				
;	PC0		SCL			I2C	TDA8425		
;	PC1		SDA			I2C	TDA8425	
;	PC2		TCK			RDDA			; RDS			
;	PC3		IMS			LCD_RS	
;	PC4		TDO			LCD_RW			
;	PC5		TDI			LCD_E
;	PC6		TOSC1		LCD_CS
;	PC7		TOSC2		LCD RES

;	PD0		RxD			TUNER_CK
;	PD1		TxD			TUNER_DI
;	PD2		INT0		RC5 reserviert		
;	PD3		INT1		RDCL			; RDS
;	PD4		OC1B		KEYB_ENTER 
;	PD5		OC1A		KEYB_ESC
;	PD6		ICP1		KEYB_DOWN
;	PD7		OC2			KEYB_UP


;*****************************************************************

;--- Allgemeines -----------------------------------------------

.equ    F_CPU           = 8000000	
.equ    CYCLES_PER_US   = ((F_CPU+800000)/1000000)

.equ	IRQ_TIME		= 10				; IRQ-Zeit in ms

.equ	VORTEILER		= 64
.equ	COUNT_IN		= F_CPU/VORTEILER	; Vorteiler 64 - 125000Hz, Vorteiler 32 - 250000 bei 8MHz

.equ    TCONST_TIME     = COUNT_IN/(1000/IRQ_TIME)									
											; mu ganzzahliger Wert zwischen 1 und 65535 sein !!!
.equ	COUNT_SEK		= 1000/IRQ_TIME		; Wert fr IRQ-Zhler, um 1s zu erreichen

.equ	REPEAT_WAIT		= 1000/IRQ_TIME		; Wartezeit zum ersten Repeat 1000ms
.equ	REPEAT_LOOP		=  100/IRQ_TIME		; Wiederholzeit wenn Repeat aktiv

.equ	I2C_FREQUENZ	= 100000

.equ	I2C_CLOCK		= ((F_CPU/I2C_FREQUENZ)-16)/2

.equ	F_MIN			= $07AC				; 87,5MHz
.equ	F_MAX			= $0946				; 108MHz

.equ	F_INIT			= $07FA
.equ	F_ZF			= 1070

.equ	PLL_MODE_1		= 0b00000001
.equ	PLL_MODE_2		= 0b00000010
.equ	PLL_MODE_3		= 0b00000011
	
.equ	REF_100			= 0b00000000
.equ	REF_50			= 0b00001000
.equ	REF_25			= 0b00000100
.equ	REF_12_5		= 0b00000010
.equ	REF_6_25		= 0b00001010
.equ	REF_3_125		= 0b00000110
.equ	REF_10			= 0b00000001
.equ	REF_9			= 0b00001001
.equ	REF_5			= 0b00000101
.equ	REF_1			= 0b00001100

.equ	REF_FMIN		= 0b00010000		; DV = 1, FMIN und HCTR			
.equ	REF_AMIN_H		= 0b00001000		; DV = 0, SP = 1, AMIN 2-40MHz und LCTR Frequenz
.equ	REF_AMIN_L		= 0b00000000		; DV = 0, SP = 0, AMIN 0,5-10MHz und LCTR Periode

.equ	CTRL_STEREO		= 0b00100000		; 1 schaltet auf Mono

.equ	RDS_REFERENZ	= 220				; ADC-Grenzwert (0...255), ab dem RDS-Signal ok ist 

.equ	SPEICHER_ANZ	= 10

.equ	M_T_SPEICHER	= 0					; Bitnummern!
.equ	M_A_VOLUMEN		= 1
.equ	M_T_SET			= 2

.equ	MENU_MAX		= 3

;--- NF-Prozessor ---------------------------------------------------------

.equ	TDA8425_WRITE	= 0b10000010
.equ	TDA8425_VOL_L	= 0b00000000
.equ	TDA8425_VOL_R	= 0b00000001
.equ	TDA8425_BASS	= 0b00000010
.equ	TDA8425_TREBLE	= 0b00000011
.equ	TDA8425_SWITCH	= 0b00001000

.equ	SWITCH_STEREO_2	= 0b11001111

;--- Display ---------------------------------------------------------

.equ	CHAR_PER_LINE 		= 22		; Font 8x6
.equ	CHAR_WIDTH			= 6			; Breite
.equ	CHAR_HEIGHT			= 11		; Hhe
.equ	GRAFIK_WIDTH		= 128
.equ	GRAFIK_HEIGHT		= 128

.equ	CHAR_WIDTH_BIG		= 12

.equ	LCD_LINES			= (GRAFIK_HEIGHT+6)/CHAR_HEIGHT		; Anzahl Zeilen

.equ	LCD_MODE			= $00
.equ	LCD_MODE_CG			= 0			; 0 -> interner CG-Rom, Grafikmode, 1 -> externer CG-Rom
.equ	LCD_MODE_TXT		= 1			; 0 -> Textmode, 1 -> Grafikmode
.equ	LCD_MODE_CUR_ON		= 2			; 0 -> Aus, 1 -> An
.equ	LCD_MODE_BLINK		= 3			; 0 -> Aus, 1 -> An
.equ	LCD_MODE_MS			= 4			; 0 -> Master, 1 -> Slave
.equ	LCD_MODE_ON			= 5			; 0 -> Aus, 1 -> An

.equ	LCD_CHAR_PITCH		= $01		; Zeichenhhe / Zeichenbreite
.equ	LCD_FONT_6x8		= ((CHAR_HEIGHT-1)<<4) | CHAR_WIDTH-1

.equ	LCD_CHAR_ANZ		= $02
.equ	LCD_DUTY			= $03
.equ	LCD_DUTY_WERT		= 63

.equ	LCD_CUR_POS			= $04		; Zeichenzeile des Cursors
.equ	LCD_DISP_L			= $08		; Startadresse der Anzeige im Ram Low
.equ	LCD_DISP_H			= $09		; Startadresse der Anzeige im Ram High
.equ	LCD_CUR_L			= $0A		; Adresse des aktuellen Zeichens Low
.equ	LCD_CUR_H			= $0B		; Adresse des aktuellen Zeichens High
.equ	LCD_WRITE			= $0C		; Daten schreiben
.equ	LCD_READ			= $0D		; Daten Lesen
.equ	LCD_CLEAR_BIT		= $0E		; lscht Bit in Cursorposition (Grafik)
.equ	LCD_SET_BIT			= $0F		; setzt Bit in Cursorposition (Grafik)

.equ	LCD_BUSY			= 7

.equ	BIG_0				= 0
.equ	BIG_1				= 1
.equ	BIG_2				= 2
.equ	BIG_3				= 3
.equ	BIG_4				= 4
.equ	BIG_5				= 5
.equ	BIG_6				= 6
.equ	BIG_7				= 7
.equ	BIG_8				= 8
.equ	BIG_9				= 9

.equ	BIG_H				= 10
.equ	BIG_M				= 11
.equ	BIG_z				= 12

.equ	BIG_SPACE			= 13
.equ	BIG_KOMMA			= 14
.equ	BIG_DOPPEL			= 15


;--- Key_Flag-Werte ------------------------------------------------

.equ	KEY_PRESS		= 0					; Taste gedrckt

.equ	KEY_REPEAT_OK	= 1					; 1 wenn erste Wartezeit vorbei
.equ	KEY_REPEAT_ON	= 2					; 1 wenn berhaupt wiederholt werden soll

.equ	MENU_RDS		= 3					; 1 wenn RDS angezeigt werden soll
.equ	MENU_SAVE		= 4					; 1 wenn Daten beim Verlassen des Men zu speichern sind

;--- Tuner_Flag-Werte ----------------------------------------------

.equ	RDS_SYNC		= 0
.equ	RDS_GROUP		= 1
.equ	RDS_TXT_AB		= 2

.equ	RDS_SCROLL		= 3					; 1 wenn weiter gescrollt werden soll

.equ	RDS_FLAG		= 4					; 1 wenn ADC RDS-Signal messen soll, 0 fr Feldstrke

.equ	PLL_MONO		= 5					; 1 VCO aus

.equ	ADC_IGNORE		= 6					; 1 wenn Dummy-Messung nach AREF-Wechsel luft

.equ	RDS_SIGNAL		= 7					; 1 wenn RDS-Signal vorhanden

;--- Analog In -----------------------------------------------------------

.equ	ADC0		 = 0b00000000
.equ	ADC1		 = 0b00000001

;**************************** Ram-Reservierungen ******************

;--- Internes Ram ------------------------------------------------

.DSEG

.ORG    $060    
LCD_LINE:		.byte	CHAR_PER_LINE + 1	; zum Scrollen		

RADIOTEXT:		.byte  64					; $0C0 - $0FF 64 byte radiotext

RADIOBUF:		.byte  32 

BLOCK1H:		.byte 	1					; $0B0 
BLOCK1L:		.byte	1					; $0B1
BLOCK2H:		.byte	1					; $0B2
BLOCK2L:		.byte	1					; $0B3  > block date (4 blocks with 16 Bit each)
BLOCK3H:		.byte	1					; $0B4
BLOCK3L:		.byte	1					; $0B5
BLOCK4H:		.byte	1					; $0B6
BLOCK4L:		.byte	1					; $0B7

PI:				.byte	2					; $0B8 16 Bit PI-Code H-L

SCROLL_COUNTER:.byte 	1					; Zeichenzeiger

PLL_CTRL:		.byte	1					; MSB...LSB
PLL_REF:		.byte	1
PLL_PORT:		.byte	1
PLL_DIV_H:		.byte	1
PLL_DIV_L:		.byte	1

IRQ_COUNT:		.byte	1					; Zhler fr 1s

FELDSTAERKE:	.byte	1

RAM_ENDE:

.ORG    $200

EE_DATA_ANF:

; 0...1 PLL, 2...10 Sender-Name, 11 Mono/Stereo
SENDER_0:		.byte  16
SENDER_1:		.byte  16
SENDER_2:		.byte  16
SENDER_3:		.byte  16
SENDER_4:		.byte  16
SENDER_5:		.byte  16
SENDER_6:		.byte  16
SENDER_7:		.byte  16
SENDER_8:		.byte  16
SENDER_9:		.byte  16

SPEICHER_AKT:	.byte	1					; aktueller Speicherplatz 

TDA_BALANCE:	.byte	1
TDA_VOL_L:		.byte	1
TDA_VOL_R:		.byte	1
TDA_BASS:		.byte	1
TDA_TREBLE:		.byte	1
TDA_SWITCH:		.byte	1	

CHECKSUM:		.byte	1					; EOR-Checksum

EE_DATA_END:

; $0300-$045F Stack                         ; 352 Byte...

;**************************** Register-Bits **************************

;--- LCD-Display ---------------------------------------------------------

; LCD-Daten Bit4...Bit7, 4-Bit-Mode
.equ	LCD_DDR		= DDRB
.equ    LCD_DATA    = PORTB                 ; Datenport
.equ    LCD_DATA_IN = PINB                  ; Datenport

.equ    LCD_CTRL    = PORTC                 ; Controlport
.equ    LCD_RS      = PC3                   ; Bit fr Register Select
.equ    LCD_RW      = PC4                   ; Bit fr Read / Write
.equ    LCD_E       = PC5                   ; Bit fr Enable
.equ    LCD_CS      = PC6                   ; Bit fr Chip Select
.equ    LCD_RES     = PC7                   ; Bit fr Reset

;--- Tuner -----------------------------------------------------------

.equ	TUNER_OUT_1	= PORTD

.equ	TUNER_OUT_2	= PORTA
.equ	TUNER_IN	= PINA

.equ	TUNER_CK	= PD0					; L in Ruhezustand
.equ	TUNER_DI	= PD1					; Daten zum Tuner (32 Bit)

.equ	TUNER_CE	= PA4					; CE L Lesen, H schreiben
.equ	TUNER_ST	= PA5					; Stereo = L
.equ	TUNER_OK	= PA6					; Abstimmung OK = L
.equ	TUNER_MU	= PA7					; Muting = H

.equ	TUNER_FE	= PA0					; ADC Feldstrke
.equ	RDS_QUALI	= PA1					; ADC RDS-Signalqualitt

.equ	RDS_C_PIN	= PIND
.equ	RDS_CLOCK	= PD3

.equ	RDS_D_PIN	= PINC
.equ	RDS_DATA	= PC2

;--- TASTER ----------------------------------------------------------

.equ    KEY_PORT    = PORTD
.equ    KEY_PIN     = PIND

.equ    KEY_MENU	= PD4
.equ    KEY_ENTER	= PD5
.equ    KEY_UP		= PD6
.equ    KEY_DOWN    = PD7

.equ    KEY_MASK    = (1<<KEY_ENTER)+(1<<KEY_MENU)+(1<<KEY_UP)+(1<<KEY_DOWN)

.equ	REPEAT_MASK	= (1<<KEY_ENTER)+(1<<KEY_MENU) ; kein Repeat fr diese Tasten

;--- lower Register -----------------------------------------------

.def	MUL_L		= r0 
.def	MUL_H		= r1 

.def	DATA0		= r2					; RDS-Daten, auch fr PLL-Daten genutzt!!! 
.def	DATA1		= r3 
.def	DATA2		= r4
.def	DATA3		= r5

.def	BITCNT		= r6
 
.def	KEY_TEMP	= r7
.def    KEY_CODE	= r8

.def	MENU_NR		= r9					; Bit-Codiert aktuelles Men
.def	SUB_MENU_NR	= r10					; Bit-Codiert Submen z.B. bei Klangeinstellungen

.def	BCD_0		= r13					; BCD value digits 1 and 0
.def	BCD_1		= r14					; BCD value digits 3 and 2
.def	BCD_2		= r15					; BCD value digit 4

.equ	AtBCD0		= 13					; address of tBCD0
.equ	AtBCD2		= 15					; address of tBCD2

;--- higher Register ----------------------------------------------

.def    TEMP_A      = r16                   ; temporre  8Bit-Register
.def    TEMP_B      = r17 
.def	TEMP_C		= r18
.def	TEMP_D		= r19

.def	TUNER_FLAGS	= r20
.def	KEY_FLAGS	= r21
.def	KEY_REPEAT	= r22

.def	RDS_BLOCK	= r23
.def	SYNC_L		= r24					; RDS
.def	SYNC_H		= r25

; r26/r27, r28/r29, r30/r31 fr X,Y,Z reserviert 

;--- Macros -------------------------------------------------------

.macro  load_p                      ; ldt 16Bit @1 nach @0 High und @0 Low

        ldi     @0H,HIGH(@1)
        ldi     @0L,LOW(@1)

.endmacro


		
