;******************************** Sub-EEPROM *******************************
; Sub:  Write EEPROM Schreibt EE_DATA_END - EE_DATA_ANF (max. 256 Byte) Byte ab EE_DATA_ANF ins EEPROM
; Parameter:    -
; Return:       - 
; Scratch-Reg:  ZL, ZH, XL, XH, TEMP_A
;***************************************************************************

eeprom_write:
		ldi		TEMP_B,EE_DATA_END - EE_DATA_ANF	; Anzahl Bytes
        load_p	Z,EE_DATA_ANF        		; Zeiger auf EEPROM-Daten
        clr     XH                          ; EEprom Adresse auf 0
        clr     XL

eeprom_write_wait_1:
		sbic    EECR,EEWE                   ; Test, ob EEWE auf 0
        rjmp    eeprom_write_wait_1

eeprom_write_loop:
        out     EEARL,XL					; EEprom Adresse setzen
        out     EEARH,XH 

        ld      TEMP_A,Z+

        out     EEDR,TEMP_A                 ; Daten schreiben

        cli									; IRQ sperren !
        sbi     EECR,EEMWE                  ; Masterbit setzen
        sbi     EECR,EEWE                   ; Write Enable
        sei

eeprom_write_wait_2:
		sbic    EECR,EEWE                   ; Test, ob EEWE auf 0
        rjmp    eeprom_write_wait_2

        adiw    XL,1                        ; Adresse erhhen

		dec		TEMP_B						; alle Byte durch ?
        brne    eeprom_write_loop			; nein 

        ret

;******************************** Sub-EEPROM *******************************
; Sub:  ee_read Liest EEPROM nach EE_DATA
; Parameter:    -
; Return:       - 
; Scratch-Reg:  ZL, ZH, XL, XH, TEMP_A
;***************************************************************************

eeprom_read:
		cli

		ldi		TEMP_B,EE_DATA_END - EE_DATA_ANF	; Anzahl Bytes
        load_p	Z,EE_DATA_ANF        		; Zeiger auf EEPROM-Daten
        clr     XH                          ; EEprom Adresse auf 0
        clr     XL

eeprom_read_loop:
        out     EEARL,XL
        out     EEARH,XH

        sbi     EECR,EERE                   ; Lesen

        in      TEMP_A,EEDR                 ; Daten holen
        st      Z+,TEMP_A

        adiw    XL,1                        ; nchste Adresse

		dec		TEMP_B						; alle Bytes ? 
        brne    eeprom_read_loop			; nein 

		sei

        ret
