;*********************************************************************
;  Setzt das nchste Men
;  In:      
;  Out:     
;  Scratch: ZH, ZL, YH, YL, TEMP_A, TEMP_B, TEMP_V
;*********************************************************************

show_menu:
		mov		TEMP_A,MENU_NR					; Nummer holen
		
		load_p	Z,(2*menu_texte)
		mov		TEMP_A,MENU_NR
		lsl		TEMP_A							; *2 fr Adresse
		add		ZL,TEMP_A
		clr		TEMP_A
		adc		ZH,TEMP_A
		lpm		YL,Z+
		lpm		YH,Z	
		mov		ZL,YL
		mov		ZH,YH
		lsl		ZL								; *2 fr Adresse
		rol		ZH

		load_p	Y,LCD_LINE
		rcall	copy_rom_txt
		ldi		TEMP_A,7						; Zeile 8
		ldi		TEMP_B,20						; Anzahl
		ldi		TEMP_C,4
		rcall	lcd_write_line
		
		ret

;*********************************************************************
;  Testet, ob das Men sinnvoll ist und wechselt dorthin, sonst ein Men weiter
;  In:      
;  Out:     
;  Scratch: ZH, ZL, YH, YL, TEMP_A, TEMP_B, TEMP_V
;*********************************************************************

sub_menu:
		rcall	show_menu						; Men anzeigen

		ldi		TEMP_A,M_A_VOLUMEN
		cp		TEMP_A,MENU_NR					; Sound?
		brne	sub_menu_end					; nein

		rcall	sound_balken

sub_menu_end:
		ret

;*********************************************************************
;  Speichert Daten bei Menwechsel
;  In:      
;  Out:     
;  Scratch: -
;*********************************************************************

save_menu_daten:
		sbrc	TUNER_FLAGS,PLL_MONO
		rcall	set_stereo_mono

		clr		SUB_MENU_NR						; Submen auf 0

		sbrs	KEY_FLAGS,MENU_SAVE				; Daten zu sichern?
		rjmp	save_menu_daten_end				; nein

save_menu_daten_end:
		ret

;*********************************************************************
;  Schreibt PLL in Speicher, berechnet Checksumme fr EEPROM, setzt Speicheranz und Platz
;  In:      
;  Out:     
;  Scratch: TEMP_A, TEMP_B, TEMP_C, TEMP_D, ZL, ZH
;*********************************************************************
					
set_frequenz_speicher:
		lds		TEMP_B,SPEICHER_AKT				; aktuellen Speicherplatz holen
		mov		TEMP_A,TEMP_B
		lds		TEMP_C,PLL_DIV_H				; letzten Speicherplatz holen
		lds		TEMP_D,PLL_DIV_L				; letzten Speicherplatz holen
		load_p	Z,SENDER_0						; erste Platzadresse
		lsl		TEMP_A
		lsl		TEMP_A
		lsl		TEMP_A
		lsl		TEMP_A							; * 16
		add		ZL,TEMP_A
		clr		TEMP_A
		adc		ZH,TEMP_A
		st		Z+,TEMP_C						; PLL-Wert merken
		st		Z+,TEMP_D
		rcall	calc_checksum
		sts		CHECKSUM,TEMP_B					; neue Prfsumme schreiben
		rcall	eeprom_write			

		sbr		KEY_FLAGS,(1<<MENU_SAVE)

		ret
				
;*********************************************************************
;  Setzt Sender auf nchsten Speicherplatz
;  In:      
;  Out:     
;  Scratch: TEMP_A
;*********************************************************************
speicher_up:
		lds		TEMP_A,SPEICHER_AKT
		inc		TEMP_A
		cpi		TEMP_A,SPEICHER_ANZ				; letzter Speicher?
		brne	speicher_up_ok

		clr		TEMP_A

speicher_up_ok:
		sts		SPEICHER_AKT,TEMP_A
		rjmp	speicher_set

;*********************************************************************
;  Setzt Sender auf vorigen Speicherplatz
;  In:      
;  Out:     
;  Scratch: TEMP_A, TEMP_C, TEMP_D, ZH, ZL
;*********************************************************************
speicher_down:
		lds		TEMP_A,SPEICHER_AKT
		tst		TEMP_A							; erster Speicher?
		brne	speicher_down_sub

		ldi		TEMP_A,SPEICHER_ANZ-1			; grten setzen
		rjmp	speicher_down_ok

speicher_down_sub:
		dec		TEMP_A

speicher_down_ok:
		sts		SPEICHER_AKT,TEMP_A

speicher_set:
		load_p	Z,SENDER_0						; erste Platzadresse
		lsl		TEMP_A
		lsl		TEMP_A
		lsl		TEMP_A
		lsl		TEMP_A							; * 16
		add		ZL,TEMP_A
		clr		TEMP_A
		adc		ZH,TEMP_A
		ld		TEMP_C,Z+						; PLL-Wert holen
		ld		TEMP_D,Z
		sts		PLL_DIV_H,TEMP_C				; PLL-Wert setzen
		sts		PLL_DIV_L,TEMP_D
		
		rcall	send_pll_daten
		rcall	show_tuner_freq_big
		rcall	show_tuner_status
		rcall	rds_buf_clear

		ret

;*********************************************************************
;  Schaltet RDS-Anzeige ein oder aus
;  In:      
;  Out:     
;  Scratch: ZL, ZH
;*********************************************************************

rds_switch:
		sbrs	TUNER_FLAGS,RDS_SIGNAL		; Sender mit RDS?
		rjmp	rds_switch_off				; nein, Anzeige immer aus

		sbrc	KEY_FLAGS,MENU_RDS			; RDS anzeigen?
		rjmp	rds_switch_off

		sbr		KEY_FLAGS,(1<<MENU_RDS)		; RDS ein
		rjmp	rds_switch_end

rds_switch_off:
		cbr		KEY_FLAGS,(1<<MENU_RDS)		; RDS ein
		ldi		TEMP_A,4					; Zeile
		rcall	lcd_clear_line
		ldi		TEMP_A,5					; Zeile
		rcall	lcd_clear_line

rds_switch_end:
		ret

;*********************************************************************
;  Steuerung Klang, erhht Wert im aktuellen Submne um 1
;  In:      
;  Out:     
;  Scratch: TEMP_A
;*********************************************************************

sub_sound_inc:
		mov		TEMP_A,SUB_MENU_NR
		cpi		TEMP_A,2					; Treble
		brne	sub_sound_inc_no_treble

		rcall	treble_inc
		rjmp	sub_sound_inc_end

sub_sound_inc_no_treble:
		cpi		TEMP_A,1					; Bass
		brne	sub_sound_inc_no_bass

		rcall	bass_inc
		rjmp	sub_sound_inc_end

sub_sound_inc_no_bass:
		rcall	volumen_inc

sub_sound_inc_end:
		rcall	sound_balken

		sbr		KEY_FLAGS,(1<<MENU_SAVE)

		ret

;*********************************************************************
;  Steuerung Klang, verringert Wert im aktuellen Submne um 1
;  In:      
;  Out:     
;  Scratch: TEMP_A
;*********************************************************************

sub_sound_dec:
		mov		TEMP_A,SUB_MENU_NR
		cpi		TEMP_A,2					; Treble
		brne	sub_sound_dec_no_treble

		rcall	treble_dec
		rjmp	sub_sound_dec_end

sub_sound_dec_no_treble:
		cpi		TEMP_A,1					; Bass
		brne	sub_sound_dec_no_bass

		rcall	bass_dec
		rjmp	sub_sound_dec_end

sub_sound_dec_no_bass:
		rcall	volumen_dec

sub_sound_dec_end:
		rcall	sound_balken

		sbr		KEY_FLAGS,(1<<MENU_SAVE)

		ret

;*********************************************************************
;  Steuerung Klang ### wird direkt mit sound_balken fortgesetzt ###
;  In:      
;  Out:     
;  Scratch: TEMP_A, YL, YH, ZL, ZH
;*********************************************************************

sub_sound_switch:
		mov		TEMP_A,SUB_MENU_NR
		inc		TEMP_A
		cpi		TEMP_A,3

		brne	sub_sound_switch_ok

		clr		TEMP_A			; wieder auf 0

sub_sound_switch_ok:
		mov		SUB_MENU_NR,TEMP_A

		load_p	Y,LCD_LINE
		load_p	Z,(2*treble_txt)
		cpi		TEMP_A,2
		breq	sub_sound_switch_end

		load_p	Z,(2*bass_txt)
		cpi		TEMP_A,1
		breq	sub_sound_switch_end

		load_p	Z,(2*volumen_txt)

sub_sound_switch_end:
		sbr		KEY_FLAGS,(1<<MENU_SAVE)

		rcall	copy_rom_txt

		ldi		TEMP_A,7						; Zeile 8
		ldi		TEMP_B,10						; Anzahl
		ldi		TEMP_C,4
		rcall	lcd_write_line

;*********************************************************************
;  Balken Klang
;  In:      
;  Out:     
;  Scratch: TEMP_A, TEMP_B, TEMP_C
;*********************************************************************

sound_balken:
		mov		TEMP_A,SUB_MENU_NR
		cpi		TEMP_A,2					; Treble
		brne	sound_balken_no_treble

		lds		TEMP_B,TDA_TREBLE
		subi	TEMP_B,0b00000010			; -12db
		andi	TEMP_B,0b00001111	
		lsl		TEMP_B						; 0...16
		lsl		TEMP_B						; 0...32
		rjmp	sound_balken_write

sound_balken_no_treble:
		cpi		TEMP_A,1					; Bass
		brne	sound_balken_no_bass

		lds		TEMP_B,TDA_BASS
		subi	TEMP_B,0b00000010			; -12db
		andi	TEMP_B,0b00001111
		lsl		TEMP_B						; 0...16
		lsl		TEMP_B						; 0...32
		rjmp	sound_balken_write

sound_balken_no_bass:
		lds		TEMP_B,TDA_VOL_L
		andi	TEMP_B,0b00011111
		lds		TEMP_A,TDA_VOL_R
		andi	TEMP_A,0b00011111
		add		TEMP_B,TEMP_A				; VOL_L + VOL_R
		lsr		TEMP_B						; Mittelwert fr Balance-Ausgleich
		subi	TEMP_B,$1D					; untere Lautstrke-Grenze anziehen
		andi	TEMP_B,0b00011111			; Bereich 0...31
					
sound_balken_write:
		tst		TEMP_B						; Lnge = 0 ?
		brne	sound_balken_write_ok

		ldi		TEMP_B,1

sound_balken_write_ok:
		ldi		TEMP_A,7					; Zeile 8
		ldi		TEMP_C,(11*CHAR_WIDTH)+4+3
		ldi		TEMP_D,$7E					; Bitmuster

		push	TEMP_B						; Lnge merken

		rcall	lcd_write_balken

		pop		TEMP_C						; Lnge jetzt Startposition
		subi	TEMP_C,-((11*CHAR_WIDTH)+4+3)	; Startspalte dazu
		ldi		TEMP_B,(11*CHAR_WIDTH)+33+4+3	; maximale Lnge + Startposition
		sub		TEMP_B,TEMP_C				; - schon geschriebener Balken
		breq	sound_balken_write_end		; nichts mehr aufzufllen
		
		ldi		TEMP_A,7					; Zeile 8
		clr		TEMP_D						; Bitmuster

		rcall	lcd_write_balken

sound_balken_write_end:
		ret




